/* Copyright (C) 2002, by Rupert Paget (rpaget@vision.ee.ethz.ch),
 * all rights reserved.
 *
 * This software is copyrighted as noted below. It may be freely copied,
 * modified, and redistributed, provided that the copyright notice is
 * preserved on all copies.
 *
 * There is no warranty or other guarantee of fitness for this software,
 * it is provided solely "as is". Bug reports or fixes may be sent
 * to the author, who may or may not act on them as he desires.
 *
 * You may not include this software in a commercial program or other
 * software product without the expressed permission of the copyright owner.
 *
 * If you modify this software, you should include a notice giving the
 * name of the person performing the modification, the date of modification,
 * and the reason for such modification.
 */


#ifndef  _G_LIB_H_
#define  _G_LIB_H_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
#include <iostream.h>

#define STRING_LENGTH  500
#define M_PI           3.14159265358979323846
#define M_PI_2         1.57079632679489661923

FILE *gfopen(char const *file_name, char const *mode);
char *gstrcpy(char *s1, char const *s2);
char *gstradd(char *s1, char const *s2);
char *gstrnew(char const *s1, char const *s2);
char const *gstrgetend(char const *s1);
char gstrcmpend(char *s1, char const *s2);
int gstrnum(char const *s);
void *gcalloc(int n, unsigned sizeof_something);
void gpause();
void grunerror(char const error_text[]);
char *gvector(int r, int size);
char **gmatrix(int r, int c, int size);
char ***gtensor(int r, int c, int d, int size);
void gvectorDelete(char *v);
void gmatrixDelete(char **m);
void gtensorDelete(char ***t);

#endif  /* _G_LIB_H_ */
