/* Copyright (C) 2002, by Rupert Paget (rpaget@vision.ee.ethz.ch),
 * all rights reserved.
 *
 * This software is copyrighted as noted below. It may be freely copied,
 * modified, and redistributed, provided that the copyright notice is
 * preserved on all copies.
 *
 * There is no warranty or other guarantee of fitness for this software,
 * it is provided solely "as is". Bug reports or fixes may be sent
 * to the author, who may or may not act on them as he desires.
 *
 * You may not include this software in a commercial program or other
 * software product without the expressed permission of the copyright owner.
 *
 * If you modify this software, you should include a notice giving the
 * name of the person performing the modification, the date of modification,
 * and the reason for such modification.
 */

#ifndef _Neighbourhood_h
#define _Neighbourhood_h

using namespace std;

class Neighbourhood {

 private:
  int lengthTotal;

  int *x, *y;         // relative x y positions;
  int index;          // vector index;
  int length;         // length of vector;
  int range;          // maximum relative range;
  int scale;          // set scale of neighbourhood;

  // neighbourhood for pyramid level above
  bool pyramid;
  int *xP, *yP;       // relative x y positions;
  int lengthP;        // length of vector;

 public:
  Neighbourhood(int order, bool square, bool pyramid = false);
  ~Neighbourhood();

  bool neigh(int &x, int &y);
  bool neigh(int &x, int &y, float Neigh, float NeighMin);
  bool neigh(int &x, int &y, int &t);
  bool neigh(int &x, int &y, int &t, float Neigh, float NeighMin);
  int getx(int index) const;
  int gety(int index) const;
  int getlength() const {return lengthTotal;}
  int getrange() const {return range*scale;}
  int getscale() const {return scale;}
  void setscale(int scaleIn) {scale = scaleIn;}
  void scaleUp() {scale *= 2;}
  void scaleDown() {scale /= 2;}

 private:
  void create(int order, bool square);
  void createP(int order, bool square);
};

#endif
