/* Copyright (C) 2002, by Rupert Paget (rpaget@vision.ee.ethz.ch),
 * all rights reserved.
 *
 * This software is copyrighted as noted below. It may be freely copied,
 * modified, and redistributed, provided that the copyright notice is
 * preserved on all copies.
 *
 * There is no warranty or other guarantee of fitness for this software,
 * it is provided solely "as is". Bug reports or fixes may be sent
 * to the author, who may or may not act on them as he desires.
 *
 * You may not include this software in a commercial program or other
 * software product without the expressed permission of the copyright owner.
 *
 * If you modify this software, you should include a notice giving the
 * name of the person performing the modification, the date of modification,
 * and the reason for such modification.
 */

#ifndef _Pyramid_h
#define _Pyramid_h

#include "ColourImage.h"
#include "GreyImage.h"
#include "Option.h"

using namespace std;

class Pyramid {
  
 private:
  /* Reference values */
  bool maskIn;

 public:
  Pyramid();
  virtual ~Pyramid();

  /* Input images */
  ColourImage imgIn;
  GreyImage imgInMask;
  int rowsIn, colsIn;

  /* Output images */
  ColourImage imgOut;
  GreyImage imgProb;
  int rowsOut, colsOut;

  /* Input image indexing */
  vector<int> *imgInIndex;
  list<int> *imgInIndexl;

  /* Output image indexing */
  int **imgOutIndex;

  /* Reference values */
  bool getMaskIn() {return maskIn;};
  
  /* Build functions */
  void load(Option &opt);
  bool reduce(Pyramid &pyramid);
};

#endif
